dis '=============================================================='
dis ' UFR forecasts (for Alun) '
dis '=============================================================='

all 0 2000

open data C:\Alundata\dfco.txt
data 1 27 dfco
open data C:\Alundata\dtot.txt
data 1 31 dtot
open data C:\Alundata\lcbonds.txt
data 1 31 lcbonds
open data C:\Alundata\ldcach.txt
data 1 31 ldcach
open data C:\Alundata\lfco.txt
data 1 31 lfco
open data C:\Alundata\lqrat.txt
data 1 31 lqrat
open data C:\Alundata\lrarch.txt
data 1 31 lrarch
open data C:\Alundata\ltdbtr.txt
data 2 31 ltdbtr
open data C:\Alundata\lsdbtrch.txt
data 1 31 lsdbtrch
open data C:\Alundata\ltrade.txt
data 1 31 ltrade

comp begg = 1
comp endd = 26
comp enddd=27
dis ' '
dis '===================================================='
dis ' Model estimation from actual data'
dis ' '
dis '===================================================='
dis ' '

linreg dfco begg endd ress
# constant dfco{1} dtot lcbonds ldcach lfco ltrade lrarch lsdbtrch ltdbtr

comp b0=%beta(1)
comp b1=%beta(2)
comp b2=%beta(3)
comp b3=%beta(4)
comp b4=%beta(5)
comp b5=%beta(6)
comp b6=%beta(7)
comp b7=%beta(8)
comp b8=%beta(9)
comp b9=%beta(10)

comp SEESQ=%SEESQ
comp t=%nobs-%NREG
comp variance = seesq/t
comp stdev=SQRT(variance)
dis ' '
dis '>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>'
dis ' '
dis ' calculate forecasts '
dis '<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<'
dis ' '

seed 1234

comp endds = 31
comp beggs= 28
set yy2007 1 1000 = 0.0
set yy2008 1 1000 = 0.0
set yy2009 1 1000 = 0.0
set yy2010 1 1000 = 0.0

infobox(action=define,progress,lower=1,upper=1000) 'Replications completed'
do z = 1, 1000
infobox(current=z)
{
set yy begg endds = 0.0
set yy begg enddd = dfco
set ressstar beggs endds = 0.0
set xx begg endds = 0.0
set xx begg enddd = lfco
set zz begg endds = 0.0
set zz begg enddd = dfco

do i=beggs, endds
{
compute udraw=%ran(stdev)
comp xx(i)=b0+b3*lcbonds(i)+b6*ltrade(i)+b8*lsdbtrch(i)+b9*ltdbtr(i)
comp yy(i)=b0+b1*yy(i-1)+b2*dtot(i)+b3*lcbonds(i)+b4*ldcach(i)+b5*xx(i)+b6*ltrade(i)+b7*lrarch(i)+b8*lsdbtrch(i)+b9*ltdbtr(i)+udraw
comp zz(i)=yy(i)-xx(i)
*comp ressstar(i) = ress(fix(%uniform(begg+1,endd)))
*comp yy(i)=b0+b1*yy(i-1)+b2*dtot(i)+b3*lcbonds(i)+b4*ldcach(i)+b5*lfco(i)+b6*lqrat(i)+b7*lrarch(i)+b8*lsdbtrch(i)+b9*ltdbtr(i)+ressstar(i)
}
end do i

comp yy2007(z) = yy(beggs)
comp yy2008(z) = yy(beggs+1)
comp yy2009(z) = yy(beggs+2)
comp yy2010(z) = yy(beggs+3)

}
end do z

INFOBOX(ACTION=REMOVE)
/*
DEDIT(NEW) forecasts.rat
STORE(org=cols)  yy2007 yy2008  yy2009 yy2010
SAVE
QUIT
*/
 print / xx
dis '================================================='
dis '================================================='
















